
import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import axes3d

from katoptron.Juelich.UQ.kde import *


def main():

    N = 1000
    g1 = np.array([0.6 + 0.6 * np.random.rand(N),
                   np.random.rand(N), 0.4+0.1*np.random.rand(N)])
    g2 = np.array([0.4+0.3 * np.random.rand(N), 0.5 *
                   np.random.rand(N), 0.1*np.random.rand(N)])
    g3 = np.array([0.3*np.random.rand(N), 0.3 *
                   np.random.rand(N), 0.3*np.random.rand(N)])

    g_total = np.concatenate((g1, g2, g3), axis=1)
    x, y, z = g_total

    fig = plt.figure()
    ax = fig.gca(projection='3d')
    ax.scatter(x, y, z)

    kernel = compute_kde(g_total)
    plot_kde(kernel, [-0.5, 1.5], [-0.5, 1.5], [0.05], [0, 1])
    plot_kde(kernel, [-0.5, 1.5], [-0.5, 1.5], [0.15], [0, 1])
    plot_kde(kernel, [-0.5, 1.5], [-0.5, 1.5], [0.25], [0, 1])
    plot_kde(kernel, [-0.5, 1.5], [-0.5, 1.5], [0.35], [0, 1])
    plot_kde(kernel, [-0.5, 1.5], [-0.5, 1.5], [0.45], [0, 1])
    plot_kde(kernel, [-0.5, 1.5], [-0.5, 1.5], [0.55], [0, 1])

    np.random.seed(42)
    p1 = box_prob_MC(kernel, [0, -0.5, 0.3], [1.5, 1.5, 0.6], 100000)
    np.random.seed(42)
    p2 = box_prob_MC(kernel, [0, -0.5, 0.3], [0.6, 1.5, 0.6], 100000)
    np.random.seed(42)
    p3 = box_prob_MC(kernel, [0.6, -0.5, 0.3], [1.5, 1.5, 0.6], 100000)

    print(p1)
    print(p3)
    print(p1-(p2+p3))

    plt.show()


if __name__ == "__main__":
    main()
