// global header of the "katoptron" module

#ifndef KATOPTRON_H
#define KATOPTRON_H

#if defined(WIN32)
#ifdef tlnos_EXPORTS
#define KATOPTRON_API __declspec(dllexport)
#else
#define KATOPTRON_API __declspec(dllimport)
#endif
#else
#define KATOPTRON_API
#endif

#include "tbox.h"

/**
 * @brief katoptron namespace
 */

namespace katoptron
{
class Problem;
class Solver;
class Dirichlet;
class Neumann;
class Medium;
class Contact;
class Source;
class RandomVariable;
class Weight;
}; // namespace katoptron

class DisplayHook;

#endif //KATOPTRON_H
